/*******************************************************************************

   SIRENE MULTISONS



    C/ PIC12F675


    AUTOR: CLAUDIO LARIOS

    DATA:14/07/2020

    P/ CCS C COMPILER V3.200

    USO DIDTICO
    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS

*******************************************************************************/
#include <12F675.h>
#device adc=10
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, PUT, BROWNOUT

//bytes
#byte  TRISIO = 0x85
#byte  GPIO   = 0x05
#byte  CMCOM  = 0X19
#byte  ANSEL  = 0X9F
#byte  TMR0   = 0X01
#byte  T1CON  = 0X10
#byte  TMR1L   = 0X0E
#byte  TMR1H   = 0X0F
#byte  WPU     = 0X95
#byte  PIE1    = 0X8C
#byte  INTCON  = 0X0B
#byte  OPTION_REG   = 0X81
// bits
#bit TMR1IF = 0xC.0

//pinos do pic

#bit piezo = 0x05.5  //pino 2 sada de som
#bit j3    = 0x05.4  //pino 3 jumper seleo de som
#bit j4    = 0x05.3  //pino 4 jumper seleo de modo de operao
#bit j5    = 0x05.2  //pino 5 jumper seleo de som
#bit j6    = 0x05.1  //pino 6 jumper seleo de som
#bit j7    = 0x05.0  //pino 7 jumper seleo de som

#define VALOR_DESLIGAMENTO 60000000 * (15) //entre parenteses os minutos 

//variveis globais

unsigned int8 cnt, auxa, auxb, auxc, auxd, auxe;
unsigned int8 vez=0;
unsigned int32 timer32=0;

/*******************************************************************************
                          SUBROTINAS
*******************************************************************************/

void inverte_saida(){
  for(auxa=0;auxa<cnt;auxa++){ delay_us(6);}
  piezo= piezo ^ 1;
}


void som_campainha_telefone(){

    for(auxd=0; auxd<3;auxd++){//numero de execues
      cnt=100;//frequencia

      for(auxc=0; auxc<20;auxc++){//passo

       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt^ 0b00001111;  //0b11010110;
     }
     delay_ms(2000);
    }
 }

void som_sirene1(){
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = 0;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene2(){//estilo = rpida
  unsigned int8 auxj=0;
  //  for(auxd=0; auxd<100;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<3;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>64)auxj=1;
       if(cnt==1)auxj=0;
       if(auxj==1){
         cnt = cnt - 1;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene3(){
    //sirene legal (alerta)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 2;
     }
  //  }
 }

 void som_sirene4(){
    //sirene alarme rpido 1 (toooouu! tooooouuu! toooouuu!)
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 2;
       }
     }
   // }
 }


void som_sirene5(){
   //sirene  disparos rpidos (usar junto com outra)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene6(){

   //sirene (iaaauuuuu!  iiiaaauuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene7(){
//sirene tipo policia
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<12;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 5;
     }
  //  }
}

void som_sirene8(){
 //sirene alarme rpido 1
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<5;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene9(){

  //som de arma espacial 1 (tchooo') lento
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene10(){
//gun space
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
  //  }
}

void som_sirene11(){
 //space gun 5 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 7;
       }
       else{
         cnt = cnt + 3;
       }
     }
   // }
}
void som_sirene12(){

       //space gun 4 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
   // }
}
void som_sirene13(){
//gun space2
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=44;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
   // }
}

void som_sirene14(){
  //space gun 3 (tchuuu! tchuuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
  //  }
}

void som_sirene15(){
  //extranha (doleto bum doleto bum)
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=37;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 20;
     }
  //  }
}

void som_sirene16(){
 //poim poim
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
   // }
}
void som_sirene17(){

  //bp
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
   // }
}

void som_sirene18(){
 //sirene alarme rpido 1
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt ^ 0b10000000;
       }
       else{
         cnt = cnt + 1;
       }
     }
  //  }
}

void som_sirene19(){
  // for(auxd=0; auxd<10;auxd++){//numero de execues
     for(auxc=0; auxc<50;auxc++){//passo
       cnt=20;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       cnt=15;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
     }
  //  }
}

void som_sirene20(){//2 tons
  
      cnt=72;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }
      cnt=81;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }
   
}

void som_sirene21(){//campainha telefone 2
  cnt=64;
 
     for(auxc=0; auxc<3;auxc++){//passo
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=102;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
     
    
    }
   
     for(auxc=0; auxc<3;auxc++){//passo
       cnt=81;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
     }
    
   
}

void som_sirene22(){
 // for(auxe=0;auxe<3;auxe++){//numero de execues
    cnt=100;//frequencia

    for(auxd=0; auxd<4;auxd++){//passo 2

     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
    }
    cnt=112;
 // }
}

void som_sirene23(){
// for(auxe=0; auxe<5;auxe++){//numero de execues
    cnt=70;//frequencia
  //poim poim
    for(auxd=0; auxd<5;auxd++){//numero de execues

     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
    }
    cnt=79;
 //}
}

void som_sirene24(){
// for(auxd=0; auxd<3;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<70;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 12;
     }
  //  }
}
/*******************************************************************************
              Rotina de Interrupo do Timer 1
*******************************************************************************/
#int_timer1
void ISR_TIMER1(){
   timer32 = timer32 + 524288;//soma valor acumulado pelo timer 1 no overflow
   TMR1IF=0;
}

/*******************************************************************************
                        ROTINA MAIN
*******************************************************************************/

void main() {

   CMCOM = 7;//desliga comparadores
   GPIO = 0;//zera tudo
   TRISIO = 0b011111;//ajusta entradas e sadas
   ANSEL = 0;// desabilita ports p/ conversores ADC
   T1CON = 0x31;//liga timer1  prescaller/8
   TMR1IF=0;
   TMR1H=0X0B;
   TMR1L=0XDC;
   WPU= 0X3F;
   OPTION_REG=0;
   PIE1=1;//liga interrupo do timer 1
   INTCON= 0B11000000;//GIE=1 /PEIE=1 //liga interrupo

  
   /*******************************************************************************
           LOOP PRINCIPAL DE REPETIO
*******************************************************************************/


   for(;;){


       vez=0;

       if(j3==0)vez=vez + 1;
       if(j5==0)vez=vez + 2;
       if(j6==0)vez=vez + 4;
       if(j7==0)vez=vez + 8;

       switch (vez){
      
       case 1:
         som_sirene2();       
       break;

       case 2:
         som_sirene3();       
       break;
       
       case 3:
         som_sirene4();       
       break;

       case 4:
         som_sirene5();       
       break;

       case 5:
         som_sirene6();       
       break;
       
       case 6:
         som_sirene7();       
       break;

       case 7:
         som_sirene1();       
       break; 
       
       case 8:
        som_sirene20();
       break;

       case 9:
         som_sirene10();       
       break;

       case 10:
         som_sirene11();       
       break;
       
       case 11:
         som_sirene12();       
       break;

       case 12:
         som_sirene13();       
       break;

       case 13:
         som_sirene14();       
       break;
       
       case 14:
         som_sirene15();       
       break;

       case 15:
         som_sirene18();       
       break;


      }//switch
      
      if(j4==0){
        if(timer32>VALOR_DESLIGAMENTO){
           timer32=0;
           sleep();// para de tocar e entra em modo 'sleep'        
         }        
      }

   }//for()
}//main()


/*
































   }//for(;;)

}//void main()


*/
